package com.mycompany.ctfposhbot_a;

import cz.cuni.amis.pogamut.sposh.context.UT2004Context;
import cz.cuni.amis.pogamut.sposh.engine.VariableContext;
import cz.cuni.amis.pogamut.sposh.executor.PrimitiveInfo;
import cz.cuni.amis.pogamut.sposh.executor.StateSense;

/**
 * Sense - we see other player.
 * @author Honza
 */
@PrimitiveInfo(name = "flagsUpdated", description = "Has any of the flags been recently updated?")
public class FlagsUpdated extends StateSense<UT2004Context, Boolean> {

    boolean firstRun = true;
    boolean ourFlagHome = false;
    boolean ourFlagHeld = false;
    boolean enemyFlagHome = false;
    boolean enemyFlagHeld = false;
    
    public FlagsUpdated(UT2004Context ctx) {
        super("flagsUpdated", ctx);
    }

    @Override
    public Boolean query(VariableContext params) {
        if (firstRun ||
            ctx.getCtf().isOurFlagHome() != ourFlagHome ||
            ctx.getCtf().isEnemyFlagHome() != enemyFlagHome ||
            ctx.getCtf().isOurFlagHeld() != ourFlagHeld ||
            ctx.getCtf().isEnemyFlagHeld() != enemyFlagHeld) {
            updateFlagInfo();
            return true;
        }
        return false;
    }
    
    public void updateFlagInfo() {
        firstRun = false;
        ourFlagHome = ctx.getCtf().isOurFlagHome();
        enemyFlagHome = ctx.getCtf().isEnemyFlagHome();
        ourFlagHeld = ctx.getCtf().isOurFlagHeld();
        enemyFlagHeld = ctx.getCtf().isEnemyFlagHeld();
    }
}
