package com.mycompany.ctfposhbot_a;

import cz.cuni.amis.pogamut.sposh.context.UT2004Context;
import cz.cuni.amis.pogamut.sposh.engine.VariableContext;
import cz.cuni.amis.pogamut.sposh.executor.PrimitiveInfo;
import cz.cuni.amis.pogamut.sposh.executor.StateSense;
import cz.cuni.amis.pogamut.ut2004.agent.module.sensomotoric.Weapon;
import cz.cuni.amis.pogamut.ut2004.communication.messages.ItemType;

/**
 * Sense - we see other player.
 * @author Honza
 */
@PrimitiveInfo(name = "isUnarmed", description = "Says whether the bot is unarmed?")
public class IsUnarmed extends StateSense<UT2004Context, Boolean> {

    public IsUnarmed(UT2004Context ctx) {
        super("isUnarmed", ctx);
    }

    @Override
    public Boolean query(VariableContext params) {        
        int totalAmmo = 0;
        for (Weapon weap: ctx.getWeaponry().getWeapons().values()) {
            if (weap.getType() == ItemType.SHIELD_GUN) continue;
            if (weap.getType() == ItemType.TRANSLOCATOR) continue;
            if (weap.getType() == ItemType.ASSAULT_RIFLE) continue;
            totalAmmo += weap.getPrimaryAmmo();
        }
        if (totalAmmo == 0) return true;
        return false;
    }
}
