package com.mycompany.ctfposhbot_a;

import cz.cuni.amis.pogamut.base.agent.navigation.IPathExecutorState;
import cz.cuni.amis.pogamut.base.agent.navigation.PathExecutorState;
import cz.cuni.amis.pogamut.sposh.engine.VariableContext;
import cz.cuni.amis.pogamut.sposh.executor.ActionResult;
import cz.cuni.amis.pogamut.sposh.executor.PrimitiveInfo;
import cz.cuni.amis.pogamut.sposh.executor.StateAction;
import cz.cuni.amis.pogamut.ut2004.communication.messages.gbinfomessages.NavPoint;
import cz.cuni.amis.utils.collections.MyCollections;
import cz.cuni.amis.utils.flag.FlagListener;
import java.util.logging.Level;

/**
 * Action that causes bot to run around the map looking for medkits.
 * @author Honza
 */
@PrimitiveInfo(name = "rethinkPath", description = "Rethink what you are doing")
public class RethinkPath extends StateAction<CTFContext> {
    
    public RethinkPath(CTFContext ctx) {
        super("rethinkPath", ctx);
    }
    
    //called when this action is scheduled to run after some other different action
    @Override
    public void init(VariableContext params) {
        //setting non-flooding log level
        ctx.getPathExecutor().getLog().setLevel(Level.WARNING);
    }

    //called each time this action is scheduled to run if previous action equals to this action
    @Override
    public ActionResult run(VariableContext params) {
        ctx.getPathExecutor().stop();
        return ActionResult.FINISHED;
    }

    // called when some other action was scheduled to run after this action
    @Override
    public void done(VariableContext params) {}
}
