package com.mycompany.ctfposhbot_a;

import cz.cuni.amis.pogamut.sposh.context.UT2004Context;
import cz.cuni.amis.pogamut.sposh.engine.VariableContext;
import cz.cuni.amis.pogamut.sposh.executor.PrimitiveInfo;
import cz.cuni.amis.pogamut.sposh.executor.StateSense;
import cz.cuni.amis.pogamut.unreal.communication.messages.UnrealId;
import cz.cuni.amis.pogamut.ut2004.communication.messages.gbinfomessages.Player;
import java.util.Map;

/**
 * Sense - we see other player.
 * @author Honza
 */
@PrimitiveInfo(name = "seeFlagbearer", description = "Do I see the flagbearer?")
public class SeeFlagbearer extends StateSense<UT2004Context, Boolean> {

    public SeeFlagbearer(UT2004Context ctx) {
        super("seeFlagbearer", ctx);
    }

    @Override
    public Boolean query(VariableContext params) {        
        Map<UnrealId, Player> visibleEnemies = ctx.getPlayers().getVisibleEnemies();
        UnrealId flagHolderId = ctx.getCtf().getOurFlag().getHolder();
        return visibleEnemies.containsKey(flagHolderId);
    }
}
